unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, StrUtils, ExtCtrls;

type
  TForm1 = class(TForm)
    RichEdit1: TRichEdit;
    RichEdit2: TRichEdit;
    Panel1: TPanel;
    Panel2: TPanel;
    Label1: TLabel;
    Button1: TButton;
    ComboBox1: TComboBox;
    Edit1: TEdit;
    Splitter1: TSplitter;

    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);

  private
    { Private declarations }
  public

    { Public declarations }
  end;

var
  Form1: TForm1;
  F: TextFile;
  posi,cnt1,cnt2: integer;
  fil: string;
  w1,w2,word,str: widestring;
  sr: TSearchRec;

  implementation
{$R *.dfm}

function find(a:widestring; b:widestring):integer;
begin
find:=0;
 if pos(a,b)=1 then find:=1;
 if pos(' '+a,b)>0  then find:=1;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  RichEdit1.Clear;  RichEdit2.Clear;
  fil:=ComboBox1.Text;
  word:=Edit1.Text;
  if fil='' then RichEdit1.Lines.Add('No dictionary selected')
  else  begin
    AssignFile(F, 'data\'+fil);
    Reset(F);
    cnt1:=0; cnt2:=0;
    while not Eof(F) do  begin
       if (cnt1>200) and (cnt2>200) then break;
       Readln(F, str);
       str:=UTF8Decode(str);
       posi:=pos('	', str);
       if posi>0 then  begin
         w1 := copy(str,0,posi-1);
         w2 := copy(str,posi+1,200);

         if find(word,w1)=1 then begin
           if cnt1<200 then RichEdit1.Lines.Add(str);
           if cnt1=200 then RichEdit1.Lines.Add(' --- only first 200 matches listed ---');
           cnt1:=cnt1+1; end;

         if find(word,w2)=1 then begin
           if cnt2<200 then RichEdit2.Lines.Add(str);
           if cnt2=200 then RichEdit2.Lines.Add(' --- only first 200 matches listed ---');
           cnt2:=cnt2+1; end;
       end;
  end;
  CloseFile(F);
 end;
 Edit1.SetFocus;
end;

procedure TForm1.FormCreate(Sender: TObject);
 begin
     RichEdit1.Lines.add(' Download full versions of dictionaries for free at ');
     RichEdit1.Lines.add(' http://www.Dicts.info ');
     RichEdit1.Lines.add(' Hundreds of dictionaries are available');
     RichEdit1.Lines.add(' for more than 30 languages.');

  if FindFirst(GetCurrentDir+'\data\*.txt',faAnyFile , sr) = 0 then begin
    posi:=0;
    repeat
     ComboBox1.Items.Add(sr.Name);
     posi:=1;
    until FindNext(sr) <> 0;
   end
  else
   begin

     RichEdit1.Lines.add('No dictionaries found in "data" directory!');
     RichEdit1.Lines.add('Get dictionaries at http://www.Dicts.info');
   end;
 end;

end.
