import java.awt.Dimension;
import java.awt.Toolkit;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.*;
import javax.swing.border.TitledBorder;
import java.awt.*;
import javax.swing.*;
import java.io.*;
import java.util.*;
import java.awt.event.*;


class Frame1 extends JFrame {
    JPanel contentPane;
    JPanel jPanel1 = new JPanel();
    JPanel jPanel2 = new JPanel();
    JPanel jPanel3 = new JPanel();
    JLabel jLabel1 = new JLabel();
    JTextField jTextField1 = new JTextField();
    JButton jButton1 = new JButton();

    BorderLayout borderLayout2 = new BorderLayout();
    FlowLayout flowLayout1 = new FlowLayout();
    BorderLayout borderLayout1 = new BorderLayout();

    JScrollPane jScrollPane1 = new JScrollPane();
    JScrollPane jScrollPane2 = new JScrollPane();
    JComboBox jComboBox1 = new JComboBox();
    JTextPane jTextPane1 = new JTextPane();
    JTextPane jTextPane2 = new JTextPane();
    TitledBorder titledBorder1 = new TitledBorder("");
    javax.swing.JSplitPane jSplitPane1 = new JSplitPane();
    java.awt.BorderLayout borderLayout3 = new BorderLayout();
    TitledBorder titledBorder2 = new TitledBorder("");
    TitledBorder titledBorder3 = new TitledBorder("");
    javax.swing.JButton jButton2 = new JButton();
    public Frame1() {
        try {
            setDefaultCloseOperation(EXIT_ON_CLOSE);
            jbInit();
            cbInit();

        } catch (Exception exception) {
            exception.printStackTrace();
        }
    }

    private void cbInit() throws Exception {
        File pathName = new File("data");
        if (!pathName.exists() || pathName.isDirectory()) {
            pathName.mkdir();
        }
        if (pathName.exists() && pathName.isDirectory()) {
            String[] fN = pathName.list();
            if (fN.length == 0) {
                jComboBox1.addItem("0 available");
                String warn =" No dictionaries found in the 'data' directory!\n You can download many free dictionaries at:\n http://www.Dicts.info ";

                jTextPane1.setText(warn);
                jTextPane2.setText("                                                                 ");
            } else {
                jTextPane1.setText(" Download full versions of dictionaries for free at \n http://www.Dicts.info \n Hundreds of dictionaries are available\n for more than 30 languages.");
                jTextPane2.setText("																");
                int cnt = 0;
                for (int i = 0; i < fN.length; i++) {
                    if (fN[i].indexOf(".txt") >= 0) {
                        cnt++;
                    }
                }
                jComboBox1.addItem(cnt + " available");
                for (int i = 0; i < fN.length; i++) {
                    if (fN[i].indexOf(".txt") >= 0) {
                        jComboBox1.addItem(fN[i]);
                    }
                }
            }
            jTextField1.requestFocus();
        } else {
            jComboBox1.addItem("0 available");
            jTextPane1.setText("Data directory could not be created!");
        }
    }


    void jButton1_actionPerformed(ActionEvent e) {
        params(0);
    }

    void jButton2_actionPerformed(ActionEvent e) {
        params(1);
    }

    void jTextField1_actionPerformed(ActionEvent e) {
        params(0);
    }

// Method reads parameters from UI searches in the file and prints results.
    public void params(int mode) {
        String word = (String) jComboBox1.getSelectedItem();
        if (jTextField1.getText().length()>0 && word.indexOf(".txt") >= 0) {
            String[] arr = searchfile("data/" + word, jTextField1.getText(),mode);
            jTextPane1.setText(arr[0]);
            jTextPane2.setText(arr[1]);
            //System.out.println(jScrollPane1.getX());
            jTextField1.requestFocus();
            jTextField1.selectAll();
            jScrollPane1.getVerticalScrollBar().setValue(0);
            jScrollPane2.getVerticalScrollBar().setValue(0);
        }
    }

// This method searches word in the selected dictionary.
// This is a brute force method which reads whole file each search.
// Method is fast enough even for big dictionaries on fast computers.
 public String[] searchfile(String input, String wo, int mode) {
   String[] arb = new String[2];
    try {
    BufferedReader in1 = new BufferedReader(new InputStreamReader(new FileInputStream(input), "UTF-8"));
    StringBuffer res1 = new StringBuffer();
    StringBuffer res2 = new StringBuffer();
    String[] arr = new String[2];
    String str;
    int cn1 = 0;
    int cn2 = 0;
    int lim=300;
    while ((str = in1.readLine()) != null) { //*******************
     arr = cols(str + "\t");
     if(arr[1].length()>0){
     if(mode==0){
         if (has(arr[0], wo) && cn1 < lim){ res1.append(" " + str + "\n"); cn1++;}
         if (has(arr[1], wo) && cn2 < lim){ res2.append(" " + swap(str) + "\n"); cn2++;}
     }
     else{
       if (arr[0].indexOf(wo)>=0 && cn1 < lim){ res1.append(" " + str + "\n"); cn1++;}
       if (arr[1].indexOf(wo)>=0 && cn2 < lim){ res2.append(" " + swap(str) + "\n"); cn2++;}
     }
}
 } //************************
 arb[0] = res1.toString();
 arb[1] = res2.toString();
 in1.close();

        } catch (IOException e) {
            System.out.println("Error: " + e);
        }
        return arb;
    }

  public static String swap(String line) {
  String[] ar;
  StringBuffer ret=new StringBuffer();
  ar=line.split("	");
  ret.append(ar[1]+"	"+ar[0]);
  if(ar.length>2)for(int i=2;i<ar.length;i++)ret.append(ar[i]);
  return ret.toString();
  }

  public static boolean has(String line, String word) {
line="; "+line+";";
  if(line.equals(word))return true;
  if(line.indexOf(" "+word)>0)return true;
    return false;

    }
// This method splits the line into two words - it is much faster than normal split()
    public static String[] cols(String word) {
        String[] arr = new String[4];
        arr[0] = "";
        arr[1] = "";
        int pos1 = 0;
        int pos2 = 0;
        int len = word.length();

        pos1 = word.indexOf("	");
        if (pos1 > 0) {
            arr[0] = word.substring(0, pos1);
        }

        pos2 = word.indexOf("	", pos1 + 1);
        if (pos1 > 0 && pos2 > 0) {
            arr[1] = word.substring(pos1 + 1, pos2);
            pos1 = pos2;
        }

        pos2 = word.indexOf("	", pos1 + 1);
        if (pos1 > 0 && pos2 > 0) {
            arr[2] = word.substring(pos1 + 1, pos2);
            pos1 = pos2;
        } else {
            arr[2] = "";
        }

        pos2 = word.indexOf("	", pos1 + 1);
        if (pos1 > 0 && pos2 > 0) {
            arr[3] = word.substring(pos1 + 1, pos2);
        } else {
            arr[3] = "";
        }

        return arr;
    }


//***************************************************************************************
//Only automatically generated code is below

     private void jbInit() throws Exception {
         contentPane = (JPanel) getContentPane();
         contentPane.setLayout(borderLayout1);
         setSize(new Dimension(631, 470));
         setTitle("Simple dictionary application");
         jPanel1.setLayout(borderLayout2);
         jPanel2.setBackground(Color.lightGray);
         jPanel2.setBorder(null);
         jPanel2.setLayout(flowLayout1);
         jPanel3.setLayout(borderLayout3);
         jButton1.setText("Search");
         jButton1.addActionListener(new Frame1_jButton1_actionAdapter(this));
         jLabel1.setText("Dictionary");
         jTextField1.setMinimumSize(new Dimension(6, 40));
         jTextField1.setPreferredSize(new Dimension(120, 23));
         jTextField1.addActionListener(new Frame1_jTextField1_actionAdapter(this));

         jComboBox1.setPreferredSize(new Dimension(200, 23));
         jTextPane1.setFont(new java.awt.Font("Default", Font.PLAIN, 12));
         jTextPane1.setBorder(null);
         jTextPane1.setDoubleBuffered(true);
         jTextPane1.setEditable(false);
         jTextPane1.setMargin(new Insets(10, 3, 3, 3));
         jTextPane2.setFont(new java.awt.Font("Default", Font.PLAIN, 12));
         jTextPane2.setBorder(null);
         jTextPane2.setDoubleBuffered(true);
         jTextPane2.setEditable(false);
         jTextPane2.setMargin(new Insets(10, 3, 3, 3));
         jScrollPane1.setBorder(null);
         jScrollPane1.setDoubleBuffered(true);
         jScrollPane2.setAutoscrolls(true);
         jScrollPane2.setBorder(null);
         jScrollPane2.setDoubleBuffered(true);
         jPanel3.setBorder(null);
         jSplitPane1.setBorder(null);
         jSplitPane1.setResizeWeight(0.5);
         jButton2.setText("Fulltext");
         jButton2.addActionListener(new Frame1_jButton2_actionAdapter(this));
         contentPane.add(jPanel1, java.awt.BorderLayout.CENTER);
         jPanel1.add(jPanel3, java.awt.BorderLayout.CENTER);
         jPanel1.add(jPanel2, java.awt.BorderLayout.NORTH);
         jPanel2.add(jLabel1);
         jPanel2.add(jComboBox1);
         jPanel2.add(jTextField1);
         jPanel2.add(jButton1);
         jPanel2.add(jButton2);
         jSplitPane1.add(jScrollPane1, JSplitPane.LEFT);
         jSplitPane1.add(jScrollPane2, JSplitPane.RIGHT);
         jScrollPane2.getViewport().add(jTextPane2);
         jScrollPane1.getViewport().add(jTextPane1);
         jPanel3.add(jSplitPane1, java.awt.BorderLayout.CENTER);
     }


}


class Frame1_jButton2_actionAdapter implements ActionListener {
    private Frame1 adaptee;
    Frame1_jButton2_actionAdapter(Frame1 adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jButton2_actionPerformed(e);
    }
}


class Frame1_jTextField1_actionAdapter implements ActionListener {
    private Frame1 adaptee;
    Frame1_jTextField1_actionAdapter(Frame1 adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {

        adaptee.jTextField1_actionPerformed(e);
    }
}


class Frame1_jButton1_actionAdapter implements ActionListener {
    private Frame1 adaptee;
    Frame1_jButton1_actionAdapter(Frame1 adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jButton1_actionPerformed(e);
    }
}













/**
 * <p>Title: Simple dictionary application</p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: All free dictionaries project http://www.Dicts.info</p>
 *
 */
public class sda_java {
    boolean packFrame = false;

    /**
     * Construct and show the application.
     */
    public sda_java() {
        Frame1 frame = new Frame1();
        // Validate frames that have preset sizes
        // Pack frames that have useful preferred size info, e.g. from their layout
        if (packFrame) {
            frame.pack();
        } else {
            frame.validate();
        }

        // Center the window
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        Dimension frameSize = frame.getSize();
        if (frameSize.height > screenSize.height) {
            frameSize.height = screenSize.height;
        }
        if (frameSize.width > screenSize.width) {
            frameSize.width = screenSize.width;
        }
        frame.setLocation((screenSize.width - frameSize.width) / 2,
                          (screenSize.height - frameSize.height) / 2);
        frame.setVisible(true);
        try {
            jbInit();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }

    /**
     * Application entry point.
     *
     * @param args String[]
     */
    public static void main(String[] args) {
/*
        SwingUtilities.invokeLater(new Runnable() {
            public void run() {
*/
Thread th=new th();

new th().start();
th.setPriority(1);
/*

                try {
                    UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
                    //UIManager.getSystemLookAndFeelClassName()
                } catch (Exception exception) {
                    exception.printStackTrace();
                }

                new app();
*/
   /*    }
        });*/
    }

 public static class th extends Thread {
   public th() {
        }
   public void run() {
    try {
        UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
   } catch (Exception exception) {
    exception.printStackTrace();
     }
  new sda_java();
  }
 }



    private void jbInit() throws Exception {
    }
}
